SystemOrganization addCategory: #'Pier-Blog-Model'!
SystemOrganization addCategory: #'Pier-Blog-Seaside'!

PRRawView subclass: #PBRssView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBRssView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:09'!
isAbstract
	^ false! !

!PBRssView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:09'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBRssView class methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:08'!
label
	^ 'RSS'! !

!PBRssView methodsFor: 'accessing' stamp: 'lr 1/20/2007 20:27'!
blog
	^ self context structure! !

!PBRssView methodsFor: 'accessing' stamp: 'lr 1/20/2007 20:27'!
posts
	^ self blog allPostsIn: self context! !

!PBRssView methodsFor: 'rendering-rss' stamp: 'lr 1/21/2007 16:43'!
renderChannel: aBlog on: rss
	rss defaultDocumentation.
	rss title: aBlog title.
	rss link: (self urlFor: aBlog on: rss).
	rss description: (self textFor: aBlog on: rss).
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aBlog publicationDate).
	rss lastBuildDate: (RRRfc822DateTime
		newDateAndTime: aBlog lastBuildDate).
	rss generator: PRDistribution productName.
	rss copyright: aBlog copyright.
	rss managingEditor: aBlog managingEditor.
	rss webMaster: aBlog webMaster! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 1/21/2007 16:44'!
renderContentOn: rss
	self renderChannel: self blog on: rss.
	self posts do: [ :each |
		rss item: [ self renderPost: each on: rss ] ]! !

!PBRssView methodsFor: 'rendering-rss' stamp: 'pmm 1/22/2007 15:52'!
renderPost: aPost on: rss
	rss title: aPost title.
	rss author: aPost author.
	rss link: (aPost link
		ifNil: [ self urlFor: aPost on: rss ]).
	rss description: (self textFor: aPost on: rss).
	rss publicationDate: (RRRfc822DateTime
		newDateAndTime: aPost publication).
	aPost enclosure ifNotNilDo: [ :enclosure |
		rss enclosure
			url: (self urlFor: enclosure on: rss);
			length: enclosure contents size;
			type: enclosure mimetype ].
	rss guid bePermaLink; with: [ self urlFor: aPost on: rss ]
		! !

!PBRssView methodsFor: 'rendering' stamp: 'lr 1/21/2007 16:51'!
renderWithContext: aContext
	| response document |
	response := WAResponse new contentType: 'application/rss+xml'.
	document := RRRssStreamDocument root: RRRssRoot new.
	document stream: response stream.
	self renderContentOn: (RRRssRenderCanvas
		context: (aContext document: document)
		callbacks: nil).
	document close.
	self session returnResponse: response! !

!PBRssView methodsFor: 'utilities' stamp: 'lr 1/21/2007 16:36'!
textFor: aStructure on: aRenderer
	| rendering html |
	rendering := WARenderingContext new document: RRRssStreamDocument forHtml.
	html := self rendererClass context: rendering callbacks: (rendering callbacksFor: self).
	self context renderer start: aStructure document in: self on: html.
	^ rendering document stream contents! !

!PBRssView methodsFor: 'utilities' stamp: 'lr 1/21/2007 16:36'!
urlFor: aStructure on: aRenderer
	^ aRenderer context actionUrl copy
		adaptToContext: (self context
			structure: aStructure);
		purgeSeasideFields! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 1/21/2007 20:23'!
renderEntry: anEntry
	self renderEntryBody: anEntry.
	self renderEntryMeta: anEntry! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 1/21/2007 20:20'!
renderEntryBody: anEntry
	html div class: 'body'; with: [ self visit: anEntry document ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-rendering' stamp: 'lr 1/21/2007 20:31'!
renderEntryMeta: anEntry
	| comments |
	comments := anEntry allCommentsIn: self context.
	html div class: 'meta'; with: [
		html span 
			class: 'author'; 
			with: 'Posted by ' , anEntry author.
		html text: ' '.
		html span
			class: 'timestamp';
			with: 'at ' , anEntry publication date printString , 
				', ' , anEntry publication time printMinutes.
		html text: ' '.
		html anchor
			class: 'comments';
			goto: (self context structure: anEntry);
			with: comments size printString , ' comment' , 
				(comments size = 1 ifFalse: [ 's' ] ifTrue: [ '' ]) ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-visiting' stamp: 'lr 1/21/2007 20:20'!
visitComment: anObject
	html div class: 'comment'; with: [ self renderEntry: anObject ]! !

!PRViewRenderer methodsFor: '*pier-blog-seaside-visiting' stamp: 'lr 1/21/2007 20:21'!
visitPost: anObject
	html div class: 'post'; with: [ self renderEntry: anObject ]! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'pmm 1/22/2007 15:48'!
isFile
	^false! !

!PRStructure methodsFor: '*pier-blog-model-testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ false! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitBlog: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:11'!
visitComment: anObject
	self visitEntry: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 21:51'!
visitEntry: anObject
	self visitCase: anObject! !

!PRVisitor methodsFor: '*pier-blog-model' stamp: 'lr 1/15/2007 16:08'!
visitPost: anObject
	self visitEntry: anObject! !

PRDefaultView subclass: #PBBlogView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Seaside'!

!PBBlogView class methodsFor: 'testing' stamp: 'lr 1/15/2007 21:05'!
isAbstract
	^ false! !

!PBBlogView class methodsFor: 'testing' stamp: 'lr 1/19/2007 19:13'!
isValidIn: aContext
	^ (super isValidIn: aContext) and: [ aContext structure isBlog ]! !

!PBBlogView methodsFor: 'accessing' stamp: 'lr 1/20/2007 20:27'!
blog
	^ self context structure! !

!PBBlogView methodsFor: 'accessing' stamp: 'lr 1/20/2007 20:27'!
posts
	^ self blog allPostsIn: self context! !

!PBBlogView methodsFor: 'rendering' stamp: 'lr 1/21/2007 16:48'!
renderContentOn: html
	super renderContentOn: html.
	html div class: 'posts'; with: [ 
		self posts do: [ :each |
			html heading 
				level: 2; 
				with: each title.
			self renderPost: each on: html ] ]! !

!PBBlogView methodsFor: 'rendering' stamp: 'lr 1/17/2007 23:14'!
renderPost: aPost on: html
	html div 
		class: 'post'; 
		with: [ self render: aPost on: html ]! !

!PBBlogView methodsFor: 'updating' stamp: 'pmm 1/22/2007 13:44'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot rss
		title: self context structure title;
		url: (aHtmlRoot context actionUrl copy
			adaptToContext: (self context
				command: (PRViewCommand new
					viewComponentClass: PBRssView;
					yourself));
			purgeSeasideFields)! !

!PRFile methodsFor: '*pier-blog-model-testing' stamp: 'pmm 1/22/2007 15:48'!
isFile
	^true! !

PRCase subclass: #PBBlog
	instanceVariableNames: 'caption managingEditor webMaster copyright'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeParentOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBBlog class methodsFor: 'accessing-resources' stamp: 'lr 1/15/2007 19:36'!
icon
	"PRCompatibility compileFileNamed: 'icons/blog.png' into: PBBlog class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 14 0 0 0 14 8 6 0 0 0 31 72 45 209 0 0 0 4 103 65 77 65 0 0 175 200 55 5 138 233 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 67 73 68 65 84 120 218 140 146 77 72 20 97 24 199 127 243 206 204 206 180 49 69 34 219 22 230 33 161 72 68 42 195 40 242 150 135 80 161 75 116 16 235 80 135 110 158 250 184 69 208 165 58 175 7 111 65 65 72 5 66 82 17 81 212 33 131 252 202 200 37 138 172 214 66 212 93 221 252 216 221 249 234 153 89 20 234 212 59 243 12 207 251 206 243 127 158 247 121 254 127 237 115 23 233 16 6 131 144 52 176 73 131 64 147 143 188 255 174 245 163 25 177 14 35 2 169 244 238 214 146 27 80 115 252 12 90 185 72 144 255 10 115 89 76 75 199 178 20 122 100 166 142 82 129 96 130 84 238 217 228 144 17 134 236 245 66 13 189 126 31 59 187 175 253 85 98 245 253 35 220 225 12 186 159 199 52 21 232 98 94 41 250 117 192 144 107 41 67 50 26 134 207 204 157 75 104 74 146 108 77 145 108 104 193 105 238 4 177 202 232 109 130 241 126 148 38 64 101 197 73 141 168 182 50 53 188 197 239 132 11 14 184 5 130 31 75 44 77 13 176 242 177 141 109 71 207 97 29 60 139 155 176 225 93 31 97 224 111 0 37 11 132 181 245 212 245 222 143 183 165 47 175 113 39 239 81 202 189 98 118 240 3 169 174 91 216 77 167 41 191 21 96 113 126 29 2 102 66 134 144 240 89 120 145 97 113 100 0 187 161 13 231 100 6 103 255 41 172 66 150 249 199 87 171 77 55 245 72 139 94 21 24 205 216 222 108 226 80 64 141 244 81 122 122 153 153 254 14 214 166 223 96 31 187 72 178 174 5 47 55 74 254 101 6 235 240 121 220 74 149 21 37 252 17 132 21 130 210 28 134 87 192 177 92 18 249 73 102 31 246 198 1 137 214 11 32 109 149 243 191 226 125 88 211 88 5 250 2 92 94 43 96 180 95 199 185 242 19 171 253 6 182 92 157 226 44 197 177 7 88 123 218 209 236 237 184 43 203 49 192 55 106 54 128 154 43 78 178 241 68 117 90 205 221 40 225 53 226 201 93 152 142 207 116 187 54 174 26 251 233 166 106 156 46 60 38 109 157 213 236 19 182 28 234 193 157 184 43 65 26 150 82 4 217 231 228 167 199 133 158 41 252 194 10 185 155 221 172 78 12 163 71 250 251 212 201 104 234 200 174 3 136 164 52 121 116 169 22 200 21 188 178 80 90 145 254 197 42 107 226 139 96 252 114 52 77 31 237 247 183 49 77 68 190 67 18 12 69 50 226 255 214 88 36 242 63 2 12 0 161 205 214 237 154 234 71 98 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!PBBlog class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
isAbstract
	^ false! !

!PBBlog methodsFor: 'visiting' stamp: 'lr 1/15/2007 20:05'!
accept: aVisitor
	aVisitor visitBlog: self! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 1/21/2007 20:08'!
allPostsIn: aContext
	^ (aContext enumerator
		select: [ :each | each isPost and: [ each publication < TimeStamp now ] ])
		sort: [ :a :b | a publication > b publication ]! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright
	^ copyright! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/19/2007 19:18'!
copyright: aString
	copyright := aString! !

!PBBlog methodsFor: 'testing' stamp: 'lr 1/15/2007 21:06'!
isBlog
	^ true! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 1/19/2007 19:14'!
isValidView: aComponentClass in: aContext
	^ super viewComponentClass ~= aComponentClass! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 1/18/2007 00:18'!
lastBuildDate
	^ TimeStamp now! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:16'!
managingEditor
	^ managingEditor! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
managingEditor: anEditor
	managingEditor := anEditor! !

!PBBlog methodsFor: 'accessing-dynamic' stamp: 'lr 1/18/2007 00:18'!
publicationDate
	^ TimeStamp now! !

!PBBlog methodsFor: '*pier-blog-seaside' stamp: 'lr 1/15/2007 20:49'!
viewComponentClass
	^ PBBlogView! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster
	^ webMaster! !

!PBBlog methodsFor: 'accessing' stamp: 'lr 1/18/2007 00:17'!
webMaster: aString
	webMaster := aString! !

PRCase subclass: #PBEntry
	instanceVariableNames: 'author email publication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

PBEntry subclass: #PBComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBPost! !

!PBComment class methodsFor: 'testing' stamp: 'lr 1/15/2007 20:04'!
canBeParentOf: aClass
	^ false! !

!PBComment methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitComment: self! !

!PBComment methodsFor: 'testing' stamp: 'lr 1/14/2007 13:23'!
isComment
	^ true! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 1/14/2007 12:40'!
descriptionAuthor
	^ (MAStringDescription selector: #author label: 'Author' priority: 110)
		comment: 'The author of this entry.';
		beEditable;
		yourself! !

!PBEntry class methodsFor: 'accessing-descriptions' stamp: 'lr 1/19/2007 18:41'!
descriptionPublication
	^ (MATimeStampDescription selector: #publication label: 'Publication' priority: 130)
		comment: 'The publication date of this entry.';
		yourself! !

!PBEntry class methodsFor: 'testing' stamp: 'lr 1/14/2007 12:36'!
isAbstract
	^ self name = #PBEntry! !

!PBEntry methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:06'!
accept: aVisitor
	self visitEntry: self! !

!PBEntry methodsFor: 'accessing-dynamic' stamp: 'lr 1/21/2007 20:08'!
allCommentsIn: aContext
	^ (aContext enumerator select: [ :each | each isComment ])
		sort: [ :a :b | a publication > b publication ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/14/2007 12:36'!
author
	^ author ifNil: [ author := self defaultAuthor ]! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/14/2007 12:36'!
author: aString
	author := aString! !

!PBEntry methodsFor: 'configuration' stamp: 'lr 1/14/2007 12:38'!
defaultAuthor
	((self respondsTo: #owner) and: [ self owner notNil ])
		ifTrue: [ ^ self owner name ].
	^ 'anonymous'! !

!PBEntry methodsFor: 'configuration' stamp: 'lr 1/19/2007 18:41'!
defaultPublication
	^ TimeStamp now! !

!PBEntry methodsFor: 'initialization' stamp: 'lr 1/19/2007 18:41'!
initialize
	super initialize.
	publication := self defaultPublication.! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication
	^ publication! !

!PBEntry methodsFor: 'accessing' stamp: 'lr 1/19/2007 18:40'!
publication: aTimeStamp
	publication := aTimeStamp! !

PBEntry subclass: #PBPost
	instanceVariableNames: 'link enclosure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Blog-Model'!

!PBPost class methodsFor: 'testing' stamp: 'lr 1/15/2007 22:02'!
canBeChildOf: aClass
	^ aClass includesBehavior: PBBlog! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'pmm 1/22/2007 15:49'!
descriptionEnclosure
	^ (PRStructureDescription selector: #enclosure label: 'Enclosure' priority: 130)
		comment: 'A media object that is attached to the item.';
		addCondition: [ :value | value isFile ] asCondition labelled: 'enclosure must be a file';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/3/2007 07:21'!
descriptionLink
	^ (MAStringDescription selector: #link label: 'Link' priority: 120)
		comment: 'The link this post should refer to, can be left empty to point to the post iteself.';
		beEditable;
		yourself! !

!PBPost class methodsFor: 'accessing-descriptions' stamp: 'lr 1/19/2007 18:41'!
descriptionPublication
	^ super descriptionPublication
		beEditable;
		yourself! !

!PBPost methodsFor: 'visiting' stamp: 'lr 1/15/2007 16:08'!
accept: aVisitor
	aVisitor visitPost: self! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/22/2007 14:01'!
enclosure
	^enclosure! !

!PBPost methodsFor: 'accessing' stamp: 'pmm 1/22/2007 14:01'!
enclosure: aFile 
	enclosure := aFile! !

!PBPost methodsFor: 'testing' stamp: 'lr 1/14/2007 13:44'!
isPost
	^ true! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:11'!
link
	^ link! !

!PBPost methodsFor: 'accessing' stamp: 'lr 1/3/2007 07:11'!
link: aString
	link := aString! !
